diff --git a/arch/mips/Kconfig b/arch/mips/Kconfig
index 19fbcfa..862306c9 100644
--- a/arch/mips/Kconfig
+++ b/arch/mips/Kconfig
@@ -1100,6 +1100,7 @@ config MIPS_PARAVIRT
 	select SYS_HAS_CPU_CAVIUM_OCTEON
 	select HAVE_PCI
 	select SWAP_IO_SPACE
+	select HAVE_MACH_HEAD_FILES
 	help
 	  This option supports guest running under ????
 
diff --git a/arch/mips/paravirt/Platform b/arch/mips/paravirt/Platform
index 7e76ef2..ca91528 100644
--- a/arch/mips/paravirt/Platform
+++ b/arch/mips/paravirt/Platform
@@ -3,6 +3,6 @@
 #
 platform-$(CONFIG_MIPS_PARAVIRT)	+= paravirt/
 cflags-$(CONFIG_MIPS_PARAVIRT)		+=				\
-		-I$(srctree)/arch/mips/include/asm/mach-paravirt
+		-I$(srctree)/arch/mips/paravirt/include
 
 load-$(CONFIG_MIPS_PARAVIRT)	= 0xffffffff80010000
diff --git a/arch/mips/include/asm/mach-paravirt/cpu-feature-overrides.h b/arch/mips/paravirt/include/mach/cpu-feature-overrides.h
similarity index 100%
rename from arch/mips/include/asm/mach-paravirt/cpu-feature-overrides.h
rename to arch/mips/paravirt/include/mach/cpu-feature-overrides.h
diff --git a/arch/mips/paravirt/include/mach/floppy.h b/arch/mips/paravirt/include/mach/floppy.h
new file mode 100644
index 0000000..8e17183
--- /dev/null
+++ b/arch/mips/paravirt/include/mach/floppy.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/floppy.h>
diff --git a/arch/mips/paravirt/include/mach/ide.h b/arch/mips/paravirt/include/mach/ide.h
new file mode 100644
index 0000000..1251c0c
--- /dev/null
+++ b/arch/mips/paravirt/include/mach/ide.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/ide.h>
diff --git a/arch/mips/paravirt/include/mach/ioremap.h b/arch/mips/paravirt/include/mach/ioremap.h
new file mode 100644
index 0000000..2369393
--- /dev/null
+++ b/arch/mips/paravirt/include/mach/ioremap.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/ioremap.h>
diff --git a/arch/mips/include/asm/mach-paravirt/irq.h b/arch/mips/paravirt/include/mach/irq.h
similarity index 100%
rename from arch/mips/include/asm/mach-paravirt/irq.h
rename to arch/mips/paravirt/include/mach/irq.h
diff --git a/arch/mips/include/asm/mach-paravirt/kernel-entry-init.h b/arch/mips/paravirt/include/mach/kernel-entry-init.h
similarity index 100%
rename from arch/mips/include/asm/mach-paravirt/kernel-entry-init.h
rename to arch/mips/paravirt/include/mach/kernel-entry-init.h
diff --git a/arch/mips/paravirt/include/mach/kmalloc.h b/arch/mips/paravirt/include/mach/kmalloc.h
new file mode 100644
index 0000000..4f056db
--- /dev/null
+++ b/arch/mips/paravirt/include/mach/kmalloc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kmalloc.h>
diff --git a/arch/mips/paravirt/include/mach/mangle-port.h b/arch/mips/paravirt/include/mach/mangle-port.h
new file mode 100644
index 0000000..b9736e3
--- /dev/null
+++ b/arch/mips/paravirt/include/mach/mangle-port.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mangle-port.h>
diff --git a/arch/mips/paravirt/include/mach/mc146818rtc.h b/arch/mips/paravirt/include/mach/mc146818rtc.h
new file mode 100644
index 0000000..7284af8
--- /dev/null
+++ b/arch/mips/paravirt/include/mach/mc146818rtc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mc146818rtc.h>
diff --git a/arch/mips/paravirt/include/mach/spaces.h b/arch/mips/paravirt/include/mach/spaces.h
new file mode 100644
index 0000000..39a4d72
--- /dev/null
+++ b/arch/mips/paravirt/include/mach/spaces.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/spaces.h>
diff --git a/arch/mips/paravirt/include/mach/topology.h b/arch/mips/paravirt/include/mach/topology.h
new file mode 100644
index 0000000..86e585b
--- /dev/null
+++ b/arch/mips/paravirt/include/mach/topology.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/topology.h>
diff --git a/arch/mips/paravirt/include/mach/war.h b/arch/mips/paravirt/include/mach/war.h
new file mode 100644
index 0000000..5b0422a
--- /dev/null
+++ b/arch/mips/paravirt/include/mach/war.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/war.h>