diff --git a/arch/mips/Kconfig b/arch/mips/Kconfig
index 862306c9..e539ff3 100644
--- a/arch/mips/Kconfig
+++ b/arch/mips/Kconfig
@@ -1053,6 +1053,7 @@ config NLM_XLR_BOARD
 	select SYS_HAS_EARLY_PRINTK
 	select SYS_SUPPORTS_ZBOOT
 	select SYS_SUPPORTS_ZBOOT_UART16550
+	select HAVE_MACH_HEAD_FILES
 	help
 	  Support for systems based on Netlogic XLR and XLS processors.
 	  Say Y here if you have a XLR or XLS based board.
@@ -1081,6 +1082,7 @@ config NLM_XLP_BOARD
 	select USE_OF
 	select SYS_SUPPORTS_ZBOOT
 	select SYS_SUPPORTS_ZBOOT_UART16550
+	select HAVE_MACH_HEAD_FILES
 	help
 	  This board is based on Netlogic XLP Processor.
 	  Say Y here if you have a XLP based board.
diff --git a/arch/mips/include/asm/netlogic/common.h b/arch/mips/include/asm/netlogic/common.h
index 5761664..6bab414 100644
--- a/arch/mips/include/asm/netlogic/common.h
+++ b/arch/mips/include/asm/netlogic/common.h
@@ -54,7 +54,7 @@
 #include <linux/cpumask.h>
 #include <linux/spinlock.h>
 #include <asm/irq.h>
-#include <asm/mach-netlogic/multi-node.h>
+#include <mach/multi-node.h>
 
 struct irq_desc;
 void nlm_smp_function_ipi_handler(struct irq_desc *desc);
diff --git a/arch/mips/netlogic/Platform b/arch/mips/netlogic/Platform
index fb8eb4c..8086f28 100644
--- a/arch/mips/netlogic/Platform
+++ b/arch/mips/netlogic/Platform
@@ -1,7 +1,7 @@
 #
 # NETLOGIC includes
 #
-cflags-$(CONFIG_NLM_COMMON)	+= -I$(srctree)/arch/mips/include/asm/mach-netlogic
+cflags-$(CONFIG_NLM_COMMON)	+= -I$(srctree)/arch/mips/netlogic/include
 cflags-$(CONFIG_NLM_COMMON)	+= -I$(srctree)/arch/mips/include/asm/netlogic
 
 #
diff --git a/arch/mips/include/asm/mach-netlogic/cpu-feature-overrides.h b/arch/mips/netlogic/include/mach/cpu-feature-overrides.h
similarity index 100%
rename from arch/mips/include/asm/mach-netlogic/cpu-feature-overrides.h
rename to arch/mips/netlogic/include/mach/cpu-feature-overrides.h
diff --git a/arch/mips/netlogic/include/mach/floppy.h b/arch/mips/netlogic/include/mach/floppy.h
new file mode 100644
index 0000000..8e17183
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/floppy.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/floppy.h>
diff --git a/arch/mips/netlogic/include/mach/ide.h b/arch/mips/netlogic/include/mach/ide.h
new file mode 100644
index 0000000..1251c0c
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/ide.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/ide.h>
diff --git a/arch/mips/netlogic/include/mach/ioremap.h b/arch/mips/netlogic/include/mach/ioremap.h
new file mode 100644
index 0000000..2369393
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/ioremap.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/ioremap.h>
diff --git a/arch/mips/include/asm/mach-netlogic/irq.h b/arch/mips/netlogic/include/mach/irq.h
similarity index 91%
rename from arch/mips/include/asm/mach-netlogic/irq.h
rename to arch/mips/netlogic/include/mach/irq.h
index c0dbd53..de9d4c5 100644
--- a/arch/mips/include/asm/mach-netlogic/irq.h
+++ b/arch/mips/netlogic/include/mach/irq.h
@@ -8,7 +8,7 @@
 #ifndef __ASM_NETLOGIC_IRQ_H
 #define __ASM_NETLOGIC_IRQ_H
 
-#include <asm/mach-netlogic/multi-node.h>
+#include <mach/multi-node.h>
 #define NLM_IRQS_PER_NODE	1024
 #define NR_IRQS			(NLM_IRQS_PER_NODE * NLM_NR_NODES)
 
diff --git a/arch/mips/netlogic/include/mach/kernel-entry-init.h b/arch/mips/netlogic/include/mach/kernel-entry-init.h
new file mode 100644
index 0000000..19b872be
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/kernel-entry-init.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kernel-entry-init.h>
diff --git a/arch/mips/netlogic/include/mach/kmalloc.h b/arch/mips/netlogic/include/mach/kmalloc.h
new file mode 100644
index 0000000..4f056db
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/kmalloc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kmalloc.h>
diff --git a/arch/mips/netlogic/include/mach/mangle-port.h b/arch/mips/netlogic/include/mach/mangle-port.h
new file mode 100644
index 0000000..b9736e3
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/mangle-port.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mangle-port.h>
diff --git a/arch/mips/netlogic/include/mach/mc146818rtc.h b/arch/mips/netlogic/include/mach/mc146818rtc.h
new file mode 100644
index 0000000..7284af8
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/mc146818rtc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mc146818rtc.h>
diff --git a/arch/mips/include/asm/mach-netlogic/multi-node.h b/arch/mips/netlogic/include/mach/multi-node.h
similarity index 100%
rename from arch/mips/include/asm/mach-netlogic/multi-node.h
rename to arch/mips/netlogic/include/mach/multi-node.h
diff --git a/arch/mips/netlogic/include/mach/spaces.h b/arch/mips/netlogic/include/mach/spaces.h
new file mode 100644
index 0000000..39a4d72
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/spaces.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/spaces.h>
diff --git a/arch/mips/netlogic/include/mach/topology.h b/arch/mips/netlogic/include/mach/topology.h
new file mode 100644
index 0000000..86e585b
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/topology.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/topology.h>
diff --git a/arch/mips/netlogic/include/mach/war.h b/arch/mips/netlogic/include/mach/war.h
new file mode 100644
index 0000000..5b0422a
--- /dev/null
+++ b/arch/mips/netlogic/include/mach/war.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/war.h>