diff --git a/arch/mips/Kconfig b/arch/mips/Kconfig
index e539ff3..898e875 100644
--- a/arch/mips/Kconfig
+++ b/arch/mips/Kconfig
@@ -598,6 +598,7 @@ config MIPS_MALTA
 	select SYS_SUPPORTS_ZBOOT
 	select USE_OF
 	select ZONE_DMA32 if 64BIT
+	select HAVE_MACH_HEAD_FILES
 	help
 	  This enables support for the MIPS Technologies Malta evaluation
 	  board.
diff --git a/arch/mips/include/asm/rtlx.h b/arch/mips/include/asm/rtlx.h
index c102065..8ec9ca6 100644
--- a/arch/mips/include/asm/rtlx.h
+++ b/arch/mips/include/asm/rtlx.h
@@ -9,7 +9,7 @@
 #ifndef __ASM_RTLX_H_
 #define __ASM_RTLX_H_
 
-#include <irq.h>
+#include <mach/irq.h>
 
 #define RTLX_MODULE_NAME "rtlx"
 
diff --git a/arch/mips/mti-malta/Platform b/arch/mips/mti-malta/Platform
index 2cc72c9..3a0e361 100644
--- a/arch/mips/mti-malta/Platform
+++ b/arch/mips/mti-malta/Platform
@@ -2,7 +2,7 @@
 # MIPS Malta board
 #
 platform-$(CONFIG_MIPS_MALTA)	+= mti-malta/
-cflags-$(CONFIG_MIPS_MALTA)	+= -I$(srctree)/arch/mips/include/asm/mach-malta
+cflags-$(CONFIG_MIPS_MALTA)	+= -I$(srctree)/arch/mips/mti-malta/include
 ifdef CONFIG_KVM_GUEST
     load-$(CONFIG_MIPS_MALTA)	+= 0x0000000040100000
 else
diff --git a/arch/mips/include/asm/mach-malta/cpu-feature-overrides.h b/arch/mips/mti-malta/include/mach/cpu-feature-overrides.h
similarity index 100%
rename from arch/mips/include/asm/mach-malta/cpu-feature-overrides.h
rename to arch/mips/mti-malta/include/mach/cpu-feature-overrides.h
diff --git a/arch/mips/mti-malta/include/mach/floppy.h b/arch/mips/mti-malta/include/mach/floppy.h
new file mode 100644
index 0000000..8e17183
--- /dev/null
+++ b/arch/mips/mti-malta/include/mach/floppy.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/floppy.h>
diff --git a/arch/mips/mti-malta/include/mach/ide.h b/arch/mips/mti-malta/include/mach/ide.h
new file mode 100644
index 0000000..1251c0c
--- /dev/null
+++ b/arch/mips/mti-malta/include/mach/ide.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/ide.h>
diff --git a/arch/mips/mti-malta/include/mach/ioremap.h b/arch/mips/mti-malta/include/mach/ioremap.h
new file mode 100644
index 0000000..2369393
--- /dev/null
+++ b/arch/mips/mti-malta/include/mach/ioremap.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/ioremap.h>
diff --git a/arch/mips/include/asm/mach-malta/irq.h b/arch/mips/mti-malta/include/mach/irq.h
similarity index 100%
rename from arch/mips/include/asm/mach-malta/irq.h
rename to arch/mips/mti-malta/include/mach/irq.h
diff --git a/arch/mips/include/asm/mach-malta/kernel-entry-init.h b/arch/mips/mti-malta/include/mach/kernel-entry-init.h
similarity index 100%
rename from arch/mips/include/asm/mach-malta/kernel-entry-init.h
rename to arch/mips/mti-malta/include/mach/kernel-entry-init.h
diff --git a/arch/mips/mti-malta/include/mach/kmalloc.h b/arch/mips/mti-malta/include/mach/kmalloc.h
new file mode 100644
index 0000000..4f056db
--- /dev/null
+++ b/arch/mips/mti-malta/include/mach/kmalloc.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/kmalloc.h>
diff --git a/arch/mips/include/asm/mach-malta/mach-gt64120.h b/arch/mips/mti-malta/include/mach/mach-gt64120.h
similarity index 100%
rename from arch/mips/include/asm/mach-malta/mach-gt64120.h
rename to arch/mips/mti-malta/include/mach/mach-gt64120.h
diff --git a/arch/mips/include/asm/mach-malta/malta-dtshim.h b/arch/mips/mti-malta/include/mach/malta-dtshim.h
similarity index 100%
rename from arch/mips/include/asm/mach-malta/malta-dtshim.h
rename to arch/mips/mti-malta/include/mach/malta-dtshim.h
diff --git a/arch/mips/include/asm/mach-malta/malta-pm.h b/arch/mips/mti-malta/include/mach/malta-pm.h
similarity index 100%
rename from arch/mips/include/asm/mach-malta/malta-pm.h
rename to arch/mips/mti-malta/include/mach/malta-pm.h
diff --git a/arch/mips/mti-malta/include/mach/mangle-port.h b/arch/mips/mti-malta/include/mach/mangle-port.h
new file mode 100644
index 0000000..b9736e3
--- /dev/null
+++ b/arch/mips/mti-malta/include/mach/mangle-port.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/mangle-port.h>
diff --git a/arch/mips/include/asm/mach-malta/mc146818rtc.h b/arch/mips/mti-malta/include/mach/mc146818rtc.h
similarity index 100%
rename from arch/mips/include/asm/mach-malta/mc146818rtc.h
rename to arch/mips/mti-malta/include/mach/mc146818rtc.h
diff --git a/arch/mips/include/asm/mach-malta/spaces.h b/arch/mips/mti-malta/include/mach/spaces.h
similarity index 100%
rename from arch/mips/include/asm/mach-malta/spaces.h
rename to arch/mips/mti-malta/include/mach/spaces.h
diff --git a/arch/mips/mti-malta/include/mach/topology.h b/arch/mips/mti-malta/include/mach/topology.h
new file mode 100644
index 0000000..86e585b
--- /dev/null
+++ b/arch/mips/mti-malta/include/mach/topology.h
@@ -0,0 +1,2 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+#include <asm/mach-generic/topology.h>
diff --git a/arch/mips/include/asm/mach-malta/war.h b/arch/mips/mti-malta/include/mach/war.h
similarity index 100%
rename from arch/mips/include/asm/mach-malta/war.h
rename to arch/mips/mti-malta/include/mach/war.h
diff --git a/arch/mips/mti-malta/malta-setup.c b/arch/mips/mti-malta/malta-setup.c
index c4ad5a9..5571b5d 100644
--- a/arch/mips/mti-malta/malta-setup.c
+++ b/arch/mips/mti-malta/malta-setup.c
@@ -16,7 +16,7 @@
 
 #include <asm/dma-coherence.h>
 #include <asm/fw/fw.h>
-#include <asm/mach-malta/malta-dtshim.h>
+#include <mach/malta-dtshim.h>
 #include <asm/mips-cps.h>
 #include <asm/mips-boards/generic.h>
 #include <asm/mips-boards/malta.h>